/**
 * Copyright (c) 2009 Mia-Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Gregoire Dupe (Mia-Software) - initial API and implementation
 */
package org.eclipse.gmt.modisco.java.discoverer.benchmark;

import java.util.Map;

import org.eclipse.gmt.modisco.infra.discoverymanager.DiscoveryParameter;
import org.eclipse.gmt.modisco.java.discoverer.benchmark.emf.client.JavaDiscovererClassicalEMF;
import org.eclipse.gmt.modisco.java.discoverer.benchmark.emf.client.JavaDiscovererIncrementalEMF;
import org.eclipse.jdt.core.IJavaProject;

public class RunBenchmarkIncVsClassical extends AbstractRunBenchmark {

	private static final int NB_BENCHMARK = 10;

	@Override
	public void discoverElement(final Object source,
			final Map<DiscoveryParameter, Object> parameters) {
		for (int i = 0; i < RunBenchmarkIncVsClassical.NB_BENCHMARK; i++) {
			initStatProject((IJavaProject) source);
			// XMI, incremental
			disco(source, JavaDiscovererIncrementalEMF.class);
			// Reference discoverer
			disco(source, JavaDiscovererClassicalEMF.class);
		}
		copyLog();
	}

}
