/**
 * Copyright (c) 2009 Mia-Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Grgoire Dup (Mia-Software) - initial API and implementation
 * 
 *
 * $Id$
 */
package org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Benchmark</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Benchmark#getJavaProjectName <em>Java Project Name</em>}</li>
 *   <li>{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Benchmark#getXmx <em>Xmx</em>}</li>
 *   <li>{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Benchmark#getConfigurations <em>Configurations</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.ReportmodelPackage#getBenchmark()
 * @model
 * @generated
 */
public interface Benchmark extends EObject {
	/**
	 * Returns the value of the '<em><b>Java Project Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Java Project Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Java Project Name</em>' attribute.
	 * @see #setJavaProjectName(String)
	 * @see org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.ReportmodelPackage#getBenchmark_JavaProjectName()
	 * @model
	 * @generated
	 */
	String getJavaProjectName();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Benchmark#getJavaProjectName <em>Java Project Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Java Project Name</em>' attribute.
	 * @see #getJavaProjectName()
	 * @generated
	 */
	void setJavaProjectName(String value);

	/**
	 * Returns the value of the '<em><b>Xmx</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Xmx</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Xmx</em>' attribute.
	 * @see #setXmx(int)
	 * @see org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.ReportmodelPackage#getBenchmark_Xmx()
	 * @model
	 * @generated
	 */
	int getXmx();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Benchmark#getXmx <em>Xmx</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Xmx</em>' attribute.
	 * @see #getXmx()
	 * @generated
	 */
	void setXmx(int value);

	/**
	 * Returns the value of the '<em><b>Configurations</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.Configuration}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Configurations</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Configurations</em>' containment reference list.
	 * @see org.eclipse.gmt.modisco.java.discoverer.benchmark.reportmodel.ReportmodelPackage#getBenchmark_Configurations()
	 * @model containment="true"
	 * @generated
	 */
	EList<Configuration> getConfigurations();

} // Benchmark
