/*******************************************************************************
 * Copyright (c) 2009 Mia-Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Gabriel Barbier (Mia-Software)
 *******************************************************************************/
package org.eclipse.gmt.modisco.kdm.browser.extension.core;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;
import org.eclipse.gmt.modisco.kdm.browser.extension.Activator;
import org.eclipse.gmt.modisco.omg.kdm.core.*;

/**
 * @generated
 */
public class IconProvider implements org.eclipse.gmt.modisco.infra.browser.uicore.extensions.icons.IconProvider {
//	Start of user code Image attribute for KDMEntity		
	private Image KDMEntityImage = this.createImage("");
//	End of user code
//	Start of user code Image attribute for KDMRelationship		
	private Image KDMRelationshipImage = this.createImage("");
//	End of user code
//	Start of user code Image attribute for AggregatedRelationship		
	private Image AggregatedRelationshipImage = this.createImage("");
//	End of user code
//	Start of user code Image attribute for ModelElement		
	private Image ModelElementImage = this.createImage("");
//	End of user code
//	Start of user code Image attribute for Element		
	private Image ElementImage = this.createImage("");
//	End of user code
	

	/**
	 * @generated
	 */	
	public IconProvider() {
	}

	/**
	 * @return the icon that must be displayed for the given {@link EObject}, or <code>null</code>
	 *         to keep the default icon, which can be empty, or let another {@link IconProvider}
	 *         provide the icon
	 * @generated
	 */
	public Image getIcon(EObject eObject) {
    Image result = null;
    if (eObject instanceof KDMEntity) {
      result = this.KDMEntityImage;
    } else
    if (eObject instanceof KDMRelationship) {
      result = this.KDMRelationshipImage;
    } else
    if (eObject instanceof AggregatedRelationship) {
      result = this.AggregatedRelationshipImage;
    } else
    if (eObject instanceof ModelElement) {
      result = this.ModelElementImage;
    } else
    if (eObject instanceof Element) {
      result = this.ElementImage;
    } 

    return result;

  }

	/**
	 * Create an image from a resource in the bundle (plugin)
	 * 
	 * @param resourcePath
	 *            the path of the resource (in the bundle)
	 * @return the image
	 * @generated
	 */
	private Image createImage(String resourcePath) {
    Image result = null;
    if ((resourcePath != null) && (resourcePath.length() > 0)) {
      ImageDescriptor descriptor = Activator.getImageDescriptor("icons/kdm/core/" + resourcePath);
      if (descriptor != null) {
        result = descriptor.createImage();
      }
    }
    return result;
  }

}

