/*******************************************************************************
 * Copyright (c) 2009 Mia-Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Nicolas Payneau (Mia-Software) - initial API and implementation
 *******************************************************************************/
package org.eclipse.gmt.modisco.workflow;

/**
 * Application constants
 * 
 * @author Nicolas Payneau
 * 
 */
public enum Constants {
	addMode, editMode, loadMode, deleteFromLauncherMode, deleteFromWorkflowMode, LaunchConfigurationNotFound, MoDiscoWorkflowSelected, Ok, Cancel;

	public static final String pathIconNew = "icon/addMoDiscoWork.png"; //$NON-NLS-1$
	public static final String pathIconEdit = "icon/editMoDiscoWork.png"; //$NON-NLS-1$
	public static final String pathIconRemove = "icon/deleteMoDiscoWork.png"; //$NON-NLS-1$
	public static final String pathIconLoad = "icon/loadMoDiscoWork.png"; //$NON-NLS-1$
	public static final String pathIconUp = "icon/upMoDiscoWork.png"; //$NON-NLS-1$
	public static final String pathIconDown = "icon/downMoDiscoWork.png"; //$NON-NLS-1$
	public static final String pathLittleImage = "icon/modiscoWorkflow.png"; //$NON-NLS-1$
	public static final String pathBigImage = "icon/bigModiscoWorkflow.png"; //$NON-NLS-1$
	public static final String pathExportImage = "icon/exportIcon.png"; //$NON-NLS-1$
	public static final String nameElementDriver = "driverUI"; //$NON-NLS-1$
	public static final String nameElementExecution = "execution"; //$NON-NLS-1$
	public static final String nameExtensionPointWorkflow = "org.eclipse.gmt.modisco.workflow.engine"; //$NON-NLS-1$
	public static final String workflowCoreExtensionPointWorkflow = "workflowCore"; //$NON-NLS-1$
	public static final String workflowExecutionExtensionPointWorkflow = "workflowExecution"; //$NON-NLS-1$
	public static final String nameExtensionPointDriver = "org.eclipse.gmt.modisco.workflow.driver"; //$NON-NLS-1$
	public static final String configurationDefaultName = Messages.Constants_15;
	public static final String workflowExtension = "workflow"; //$NON-NLS-1$
	public static final String launchExtension = "launch"; //$NON-NLS-1$
	public static final String extensionMoDiscoWorkflow = "modiscoworkflow"; //$NON-NLS-1$
	public static final String metadataFolderName = ".metadata"; //$NON-NLS-1$
	public static final String pluginsFolderName = ".plugins"; //$NON-NLS-1$
	public static final String debugCoreFolderName = "org.eclipse.debug.core"; //$NON-NLS-1$
	public static final String launchesFolderName = ".launches"; //$NON-NLS-1$
}
